"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _react = _interopRequireDefault(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
var FIconBase = props => {
  var styles = {
    svg: {
      display: 'inline-block',
      verticalAlign: 'middle'
    },
    path: {
      fill: props.color
    }
  };
  var lpaths = typeof props.icon == "string" ? [props.icon] : props.icon;
  return /*#__PURE__*/_react.default.createElement("svg", {
    style: styles.svg,
    width: "".concat(props.size, "px"),
    height: "".concat(props.size, "px"),
    viewBox: "0 0 1024 1024"
  }, lpaths.map((p, i) => /*#__PURE__*/_react.default.createElement("path", {
    key: i,
    style: styles.path,
    d: p
  })));
};
FIconBase.propTypes = {
  icon: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.arrayOf(_propTypes.default.string)]).isRequired,
  size: _propTypes.default.number,
  color: _propTypes.default.string
};
FIconBase.defaultProps = {
  size: 16
};
var _default = FIconBase;
exports.default = _default;