"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _react = _interopRequireDefault(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _formiga = require("formiga");
var _FFormButtons = _interopRequireDefault(require("./FFormButtons"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
var FForm = props => {
  var {
    id,
    children,
    className,
    onSave,
    onCancel,
    colors,
    icons,
    labels,
    autoDisable,
    disabled,
    renderButtons,
    inline
  } = props;
  var form = (0, _formiga.useForm)();
  return /*#__PURE__*/_react.default.createElement("form", {
    ref: form.ref,
    id: id,
    className: "formiga-reactstrap-form ".concat(className != undefined ? className : '', " ").concat(inline == true ? 'inline' : ''),
    noValidate: true
  }, /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, children, renderButtons == undefined ? /*#__PURE__*/_react.default.createElement(_FFormButtons.default, {
    onSave: onSave != undefined ? ev => onSave(form.valid, form.elements, ev) : undefined,
    onCancel: onCancel != undefined ? ev => onCancel(form.valid, form.elements, ev) : undefined,
    colors: colors,
    icons: icons,
    labels: labels,
    autoDisable: autoDisable,
    disabled: disabled,
    valid: form.valid,
    elements: form.elements
  }) : renderButtons(form.valid, form.elements)));
};
FForm.propTypes = {
  className: _propTypes.default.string,
  id: _propTypes.default.string,
  colors: _propTypes.default.arrayOf(_propTypes.default.string),
  icons: _propTypes.default.arrayOf(_propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.element, _propTypes.default.func])),
  labels: _propTypes.default.arrayOf(_propTypes.default.string),
  onSave: _propTypes.default.func,
  onCancel: _propTypes.default.func,
  autoDisable: _propTypes.default.bool,
  disabled: _propTypes.default.oneOfType([_propTypes.default.bool, _propTypes.default.func]),
  renderButtons: _propTypes.default.func,
  inline: _propTypes.default.bool
};
FForm.defaultProps = {
  icons: ['ban', 'save'],
  autoDisable: true,
  inline: false
};
var _default = FForm;
exports.default = _default;