"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _react = _interopRequireWildcard(require("react"));
var _FIcon = _interopRequireDefault(require("../commons/icons/FIcon.cjs"));
var _reactstrap = require("reactstrap");
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
var FFormButtons = _ref => {
  var {
    onSave,
    onCancel,
    colors,
    icons,
    labels,
    autoDisable,
    disabled,
    valid,
    elements
  } = _ref;
  var [isSaving, setIsSaving] = (0, _react.useState)(false);
  var isMounted = (0, _react.useRef)(undefined);
  (0, _react.useEffect)(() => {
    isMounted.current = true;
    return () => {
      isMounted.current = false;
    };
  }, []);
  var isDisabled = autoDisable ? !valid : typeof disabled == "function" ? disabled(valid, elements) : disabled;
  var handleSave = ev => {
    setIsSaving(true);
    var result = onSave(ev);
    if (result == Promise.resolve(result)) {
      result.then(_ => {
        if (isMounted.current) {
          setIsSaving(false);
        }
      });
    } else {
      setIsSaving(false);
    }
  };
  return /*#__PURE__*/_react.default.createElement("div", {
    className: "formiga-reactstrap-buttons"
  }, onCancel != undefined ? /*#__PURE__*/_react.default.createElement(_reactstrap.Button, {
    color: colors ? colors[0] : 'secondary',
    onClick: ev => onCancel(ev)
  }, /*#__PURE__*/_react.default.createElement(_FIcon.default, {
    icon: icons[0]
  }), labels ? labels[0] : 'Cancelar') : null, onSave != undefined ? /*#__PURE__*/_react.default.createElement(_reactstrap.Button, {
    color: colors ? colors[1] : 'primary',
    onClick: ev => handleSave(ev),
    disabled: isSaving || isDisabled
  }, /*#__PURE__*/_react.default.createElement(_FIcon.default, {
    icon: icons[1]
  }), labels ? labels[1] : 'Guardar') : null);
};
var _default = FFormButtons;
exports.default = _default;