"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _react = _interopRequireDefault(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _FInputDateBase = _interopRequireDefault(require("./FInputDateBase.cjs"));
var _isoToDate = require("./isoToDate.cjs");
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return typeof key === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (typeof input !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (typeof res !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
var dateAdjustOffset = (d, f) => {
  var offs = d.getTimezoneOffset() * f;
  var msecs = offs * 60 * 1000;
  d.setTime(d.getTime() + msecs);
  return d;
};
var unixToISO = value => {
  if (!value || isNaN(value)) {
    return undefined;
  }
  var date = new Date(value * 1000);
  date = dateAdjustOffset(date, -1);
  return date.toISOString();
};
var unixFromISO = value => {
  if (!value) {
    return undefined;
  }
  var date = dateAdjustOffset((0, _isoToDate.isoToDate)(value), 1);
  var usecs = Math.floor(date.getTime() / 1000);
  return usecs;
};
var FInputEpoch = props => {
  return /*#__PURE__*/_react.default.createElement(_FInputDateBase.default, _objectSpread(_objectSpread({}, props), {}, {
    transform: {
      fromISO: unixFromISO,
      toISO: unixToISO
    }
  }));
};
FInputEpoch.propTypes = _objectSpread(_objectSpread({}, _FInputDateBase.default.propTypes), {}, {
  value: _propTypes.default.number
});
FInputEpoch.defaultProps = _objectSpread({}, _FInputDateBase.default.defaultProps);
var _default = FInputEpoch;
exports.default = _default;