"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _react = _interopRequireWildcard(require("react"));
var _floatConv = require("./floatConv.cjs");
var _countDecimals = _interopRequireDefault(require("../../helpers/float/countDecimals.cjs"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
var getInnerSum = (summed, value) => {
  if (summed == undefined || value == undefined || value.length == 0) {
    return 0;
  }
  // Round sum to the max number of decimals
  var decs = value.map(f => (0, _countDecimals.default)(f));
  var maxd = Math.max(...decs);
  return summed.toFixed(maxd);
};
var getInnerSumRepr = (innerSum, decimalSign) => {
  return innerSum.toString().replace('.', decimalSign);
};
var FFSTotal = _ref => {
  var {
    value,
    decimalSign
  } = _ref;
  var [innerSum, setInnerSum] = (0, _react.useState)(getInnerSum((0, _floatConv.sumFloatList)(value), value));
  var [innerSumRepr, setInnerSumRepr] = (0, _react.useState)(getInnerSumRepr(innerSum, decimalSign));
  (0, _react.useEffect)(() => {
    var nInnerSum = getInnerSum((0, _floatConv.sumFloatList)(value), value);
    setInnerSum(nInnerSum);
    setInnerSumRepr(getInnerSumRepr(nInnerSum, decimalSign));
  }, [value, decimalSign]);
  return /*#__PURE__*/_react.default.createElement("div", {
    className: "formiga-reactstrap-float-sum-total"
  }, isNaN(innerSum) ? '' : innerSumRepr);
};
var _default = FFSTotal;
exports.default = _default;