"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _react = _interopRequireWildcard(require("react"));
var _isControlled = _interopRequireDefault(require("../../helpers/props/isControlled.cjs"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
var withWrapControlledForArray = function withWrapControlledForArray(BaseComponent) {
  var eventName = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 'onBlur';
  var _withWrapControlledForArray = props => {
    var controlled = (0, _isControlled.default)(props);
    var {
      value,
      defaultValue,
      onChange
    } = props;
    var initialValue = (0, _react.useRef)(controlled ? value : defaultValue);
    var [innerValue, setInnerValue] = (0, _react.useState)(controlled ? value : defaultValue);
    (0, _react.useEffect)(() => {
      var nInnerValue = controlled ? value : defaultValue;
      setInnerValue(nInnerValue);
    }, [value, defaultValue, controlled]);
    var setValue = (0, _react.useCallback)((newValue, confirmed, event) => {
      //console.log('withWrapControlledForArray.setValue ' + newValue)
      setInnerValue(newValue);
      if (onChange != undefined) {
        onChange(newValue, confirmed, event);
      }
    }, [setInnerValue, onChange]);
    var handleChange = (0, _react.useCallback)(event => {
      //console.log('withWrapControlledForArray.handleChange')
      var newValue = event.target.value;
      setValue(newValue, false, event);
    }, [setValue]);
    var handleBlur = (0, _react.useCallback)(event => {
      //console.log('withWrapControlledForArray.handleBlur')
      var newValue = event.target.value;
      setValue(newValue, true, event);
    }, [setValue]);

    //console.log(`withWrapControlledForArray value ${value} defValue ${defaultValue} innerValue ${innerValue}`)

    return /*#__PURE__*/_react.default.createElement(BaseComponent, _extends({}, props, {
      initialValue: initialValue.current,
      value: Array.isArray(innerValue) ? innerValue : [],
      setValue: setValue,
      onChange: handleChange,
      [eventName]: handleBlur
    }));
  };
  return _withWrapControlledForArray;
};
var _default = withWrapControlledForArray;
exports.default = _default;