"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _react = _interopRequireWildcard(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _formiga = require("formiga");
var _reactstrap = require("reactstrap");
var _FInputAddon = require("../../addon/FInputAddon.cjs");
var _FIcon = _interopRequireDefault(require("../../../commons/icons/FIcon.cjs"));
var _inputPropTypes = require("../../props/inputPropTypes.cjs");
var _inputDefaultProps = require("../../props/inputDefaultProps.cjs");
var _useStepOrDecimals = _interopRequireDefault(require("../../helpers/props/useStepOrDecimals.cjs"));
var _withWrapControlled = _interopRequireDefault(require("../../helpers/props/withWrapControlled.cjs"));
var _roundFloat = _interopRequireDefault(require("../../helpers/float/roundFloat.cjs"));
var _countDecimals = _interopRequireDefault(require("../../helpers/float/countDecimals.cjs"));
var _isNotNumber = _interopRequireDefault(require("../../helpers/float/isNotNumber"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return typeof key === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (typeof input !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (typeof res !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
var wrappedCheckValue = (props, value) => {
  if (props.checkValue != undefined) {
    if (!props.checkValue(value)) {
      return false;
    }
  }
  if (props.gt != undefined) {
    if (value <= props.gt) {
      return false;
    }
  }
  if (props.lt != undefined) {
    if (value >= props.lt) {
      return false;
    }
  }
  return true;
};
var _FInputNumber = props => {
  var {
    value,
    setValue,
    id,
    name,
    placeholder,
    readOnly,
    required,
    min,
    max,
    step,
    decimals,
    autocomplete,
    t,
    inputFilter,
    inputStyle,
    showArrows,
    showValidity,
    bsSize
  } = props;
  var reprRef = (0, _react.useRef)(undefined);
  var [innerRepr, setInnerRepr] = (0, _react.useState)(t.from(value));
  var stepOrDecimals = (0, _useStepOrDecimals.default)(step, decimals);
  var input = (0, _formiga.useInput)(_objectSpread(_objectSpread({}, props), {}, {
    checkValue: v => wrappedCheckValue(props, t.to(v))
  }));
  (0, _formiga.useInputFilter)(reprRef === null || reprRef === void 0 ? void 0 : reprRef.current, inputFilter);
  var incrValue = (0, _react.useCallback)((factor, confirmed) => {
    var curValue = (0, _isNotNumber.default)(value) ? 0.0 : parseFloat(value);
    var incr = stepOrDecimals != undefined ? parseFloat(stepOrDecimals) : 1.00;
    var nValue = (0, _roundFloat.default)(curValue + parseFloat(factor) * incr, (0, _countDecimals.default)(stepOrDecimals));
    var nRepr = t.from(nValue);

    //console.log(`incrValue() current ${typeof curValue} ${curValue} + incr ${typeof incr} ${incr} => ${typeof nValue} ${nValue} (repr: ${typeof nRepr} ${nRepr})`)

    setValue(nValue, confirmed);
    input.setValue(nValue);
    input.validate();
    setInnerRepr(nRepr);
  }, [value, setValue, stepOrDecimals, t, input]);
  var handleChange = (0, _react.useCallback)(event => {
    var nRepr = event.target.value;
    var nValue = t.to(nRepr);

    //console.log(`handleChange() => ${typeof nValue} ${nValue} (repr: ${typeof nRepr} ${nRepr})`)

    setValue(nValue, false, event);
    input.setValue(nValue);
    input.validate();
    setInnerRepr(nRepr);
  }, [setValue, t, input]);
  var handleKeyDown = (0, _react.useCallback)(event => {
    if (event.key == 'ArrowUp' || event.key == 'ArrowDown') {
      event.preventDefault();
      var factor = event.key == 'ArrowUp' ? 1 : -1;
      incrValue(factor, false);
    }
  }, [incrValue]);
  var handleBlur = (0, _react.useCallback)(event => {
    var nRepr = event.target.value;
    var nValue = t.to(nRepr);
    setValue(nValue, true, event);
  }, [setValue, t]);
  var showValidProps = showValidity == 1 || showValidity == 4 ? {
    valid: input.valid,
    invalid: !input.valid
  } : {};

  //console.log(`FInputNumber => value ${value} repr ${innerRepr}`)

  return /*#__PURE__*/_react.default.createElement(_FInputAddon.FInputAddon, _extends({}, props, {
    valid: input.valid,
    invalid: !input.valid,
    feedback: input.feedback
  }), /*#__PURE__*/_react.default.createElement("input", {
    type: "number",
    id: id,
    name: name,
    ref: input.ref,
    style: {
      display: "none"
    },
    required: required,
    max: max,
    min: min,
    step: stepOrDecimals,
    defaultValue: value
  }), /*#__PURE__*/_react.default.createElement(_reactstrap.Input, _extends({
    type: "text",
    innerRef: reprRef,
    placeholder: placeholder || "",
    readOnly: readOnly != undefined ? readOnly : false,
    autoComplete: autocomplete,
    style: inputStyle,
    onKeyDown: ev => handleKeyDown(ev),
    value: innerRepr,
    onChange: handleChange,
    onBlur: handleBlur,
    bsSize: bsSize
  }, showValidProps)), showArrows ? /*#__PURE__*/_react.default.createElement("div", {
    className: "formiga-reactstrap-input-number-addon ".concat(readOnly ? 'read-only' : '')
  }, /*#__PURE__*/_react.default.createElement(_reactstrap.InputGroupText, {
    className: "formiga-reactstrap-input-number-incr",
    onClick: () => incrValue(-1, true)
  }, /*#__PURE__*/_react.default.createElement(_FIcon.default, {
    icon: "minus"
  })), /*#__PURE__*/_react.default.createElement(_reactstrap.InputGroupText, {
    className: "formiga-reactstrap-input-number-incr",
    onClick: () => incrValue(1, true)
  }, /*#__PURE__*/_react.default.createElement(_FIcon.default, {
    icon: "plus"
  }))) : null);
};
var FInputNumber = (0, _withWrapControlled.default)(_FInputNumber);
FInputNumber.propTypes = _objectSpread(_objectSpread({}, _inputPropTypes.inputPropTypes), {}, {
  defaultValue: _propTypes.default.number,
  placeholder: _propTypes.default.string,
  max: _propTypes.default.number,
  min: _propTypes.default.number,
  step: _propTypes.default.number,
  decimals: _propTypes.default.number,
  gt: _propTypes.default.number,
  lt: _propTypes.default.number,
  autocomplete: _propTypes.default.oneOf(["on", "off"]),
  showArrows: _propTypes.default.bool
});
FInputNumber.defaultProps = _objectSpread(_objectSpread({}, _inputDefaultProps.inputDefaultProps), {}, {
  showArrows: true
});
var _default = FInputNumber;
exports.default = _default;