"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _react = _interopRequireWildcard(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _formiga = require("formiga");
var _inputPropTypes = require("../../../props/inputPropTypes.cjs");
var _inputDefaultProps = require("../../../props/inputDefaultProps.cjs");
var _FInputAddon = require("../../../addon/FInputAddon.cjs");
var _useEnabledOptions = require("../useEnabledOptions.cjs");
var _parseValueDependOnOptions = require("../parseValueDependOnOptions.cjs");
var _withWrapControlled = _interopRequireDefault(require("../../../helpers/props/withWrapControlled.cjs"));
var _FISClear = _interopRequireDefault(require("./FISClear.cjs"));
var _FISInput = _interopRequireDefault(require("./FISInput.cjs"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return typeof key === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (typeof input !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (typeof res !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
var _FInputSelect = props => {
  var {
    setValue,
    allowedValues,
    disallowedValues,
    options,
    clearable
  } = props;
  var enabledOptions = (0, _useEnabledOptions.useEnabledOptions)(options, allowedValues, disallowedValues);
  var input = (0, _formiga.useInput)(_objectSpread(_objectSpread({}, props), {}, {
    checkValue: props.checkValue != undefined ? v => props.checkValue((0, _parseValueDependOnOptions.parseValueDependOnOptions)(v, enabledOptions)) : undefined
  }));
  var updValue = (0, _react.useCallback)((nValue, event) => {
    var iValue = (0, _parseValueDependOnOptions.parseValueDependOnOptions)(nValue, enabledOptions);
    setValue(iValue, true, event);
    input.setValue(iValue);
    input.validate();
  }, [input, enabledOptions, setValue]);
  var handleChange = (0, _react.useCallback)(event => {
    updValue(event.target.value, event);
  }, [updValue]);
  var handleClear = (0, _react.useCallback)(event => {
    updValue('', event);
  }, [updValue]);
  return /*#__PURE__*/_react.default.createElement(_FInputAddon.FInputAddon, _extends({}, props, {
    valid: input.valid,
    invalid: !input.valid,
    feedback: input.feedback
  }), /*#__PURE__*/_react.default.createElement(_FISInput.default, _extends({}, props, {
    valid: input.valid,
    inputRef: input.ref,
    onInputChange: handleChange,
    enabledOptions: enabledOptions
  })), clearable !== false ? /*#__PURE__*/_react.default.createElement(_FISClear.default, _extends({}, props, {
    onClear: handleClear
  })) : null);
};
var FInputSelect = (0, _withWrapControlled.default)(_FInputSelect);
FInputSelect.propTypes = _objectSpread(_objectSpread({}, _inputPropTypes.inputPropTypes), {}, {
  placeholder: _propTypes.default.string,
  options: _propTypes.default.oneOfType([_propTypes.default.object, _propTypes.default.arrayOf(_propTypes.default.array)]),
  autocomplete: _propTypes.default.oneOf(["on", "off"]),
  clearable: _propTypes.default.bool
});
FInputSelect.defaultProps = _objectSpread(_objectSpread({}, _inputDefaultProps.inputDefaultProps), {}, {
  icon: 'list',
  clearable: true
});
var _default = FInputSelect;
exports.default = _default;