"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _react = _interopRequireWildcard(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _formiga = require("formiga");
var _reactstrap = require("reactstrap");
var _inputPropTypes = require("../../props/inputPropTypes.cjs");
var _inputDefaultProps = require("../../props/inputDefaultProps.cjs");
var _FInputAddon = require("../../addon/FInputAddon.cjs");
var _withWrapControlled = _interopRequireDefault(require("../../helpers/props/withWrapControlled.cjs"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return typeof key === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (typeof input !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (typeof res !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
var _FInputText = props => {
  var {
    id,
    name,
    inputType,
    maxLength,
    minLength,
    placeholder,
    readOnly,
    required,
    autocomplete,
    inputStyle,
    showValidity,
    bsSize,
    value,
    setValue
  } = props;
  var input = (0, _formiga.useInput)(_objectSpread({}, props));
  var handleChange = (0, _react.useCallback)(event => {
    var newValue = event.target.value;
    setValue(newValue, false, event);
  }, [setValue]);
  var handleBlur = (0, _react.useCallback)(event => {
    var newValue = event.target.value;
    setValue(newValue, true, event);
  }, [setValue]);
  var showValidProps = showValidity == 1 || showValidity == 4 ? {
    valid: input.valid,
    invalid: !input.valid
  } : {};
  return /*#__PURE__*/_react.default.createElement(_FInputAddon.FInputAddon, _extends({}, props, {
    valid: input.valid,
    invalid: !input.valid,
    feedback: input.feedback
  }), /*#__PURE__*/_react.default.createElement(_reactstrap.Input, _extends({
    id: id,
    name: name,
    innerRef: input.ref,
    type: inputType || "text",
    placeholder: placeholder || "",
    readOnly: readOnly != undefined ? readOnly : false,
    required: required,
    maxLength: maxLength,
    minLength: minLength,
    autoComplete: autocomplete,
    style: inputStyle,
    bsSize: bsSize,
    value: value,
    onChange: handleChange,
    onBlur: handleBlur
  }, showValidProps)));
};
var FInputText = (0, _withWrapControlled.default)(_FInputText, v => v || '');
FInputText.propTypes = _objectSpread(_objectSpread({}, _inputPropTypes.inputPropTypes), {}, {
  inputType: _propTypes.default.string,
  placeholder: _propTypes.default.string,
  maxLength: _propTypes.default.number,
  minLength: _propTypes.default.number,
  inputFilter: _propTypes.default.oneOfType([_propTypes.default.func, _propTypes.default.instanceOf(RegExp), _propTypes.default.string]),
  autocomplete: _propTypes.default.oneOf(["on", "off"])
});
FInputText.defaultProps = _objectSpread(_objectSpread({}, _inputDefaultProps.inputDefaultProps), {}, {
  icon: 'text',
  inputType: 'text',
  placeholder: ''
});
var _default = FInputText;
exports.default = _default;