"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.inputPropTypes = void 0;
var _propTypes = _interopRequireDefault(require("prop-types"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
var inputPropTypes = {
  // Props for formiga
  feedback: _propTypes.default.string,
  checkValue: _propTypes.default.Promise || _propTypes.default.func,
  allowedValues: _propTypes.default.arrayOf(_propTypes.default.any),
  disallowedValues: _propTypes.default.arrayOf(_propTypes.default.any),
  doRepeat: _propTypes.default.string,
  doNotRepeat: _propTypes.default.string,
  id: _propTypes.default.string,
  name: _propTypes.default.string.isRequired,
  value: function value(props, _propName, _componentName) {
    if (!('value' in props) && !('defaultValue' in props)) {
      return new Error('Please provide a {value} or a {defaultValue}');
    }
  },
  defaultValue: _propTypes.default.string,
  label: _propTypes.default.string,
  description: _propTypes.default.string,
  icon: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.element, _propTypes.default.func, _propTypes.default.bool]),
  inline: _propTypes.default.bool,
  readOnly: _propTypes.default.bool,
  required: _propTypes.default.bool,
  onChange: _propTypes.default.func,
  bsSize: _propTypes.default.oneOf(['', 'lg', 'sm']),
  keepHeight: _propTypes.default.bool,
  showValidity: _propTypes.default.oneOf([0, 1, 2, 4]),
  formGroupStyle: _propTypes.default.object,
  inputGroupStyle: _propTypes.default.object,
  inputStyle: _propTypes.default.object
};
exports.inputPropTypes = inputPropTypes;